<!-- This is a content page that describes the shoppingCart/checkout page-->
<!-- Made by Micheal Mishin, modified by Franco Moro-->
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:p="http://primefaces.org/ui"
    xmlns:b="http://bootsfaces.net/ui" 
    xmlns:f="http://xmlns.jcp.org/jsf/core"
    xmlns:jsf="http://xmlns.jcp.org/jsf">

    <b:container fluid="true" class="mt-5">
        <div class="row">
            <!-- Items -->
            <div class="col-md-8 mt-3">
                <div class="gradientLightGray cardShadow p-3">
                    <h3>#{msgs.shoppingCart}</h3>
                    <div>
                        <!-- TODO: list of selected item will be here -->
                            <table class="shoppingCartTable">
                            <thead>
                                <tr>
                                    <th colspan="2">#{msgs.cartItems}</th>
                                    <th>#{msgs.cartPrice}</th>
                                    <th>#{msgs.cartActions}</th>
                                </tr>
                            </thead>
                            <tbody>
                                <ui:repeat rendered="#{!shoppingCartBean.isEmpty()}" value="#{shoppingCartBean.books}" var="book">
                                <tr>
                                    <td>
                                        <h:graphicImage library="images" name="coverImages/#{book.imageUrl}" class="cardShadow bookCoverSize"/>
                                    </td>
                                    <td>
                                        <h:form>
                                            <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(book,user.userId)}">#{book.title}</h:commandLink><br/>
                                        </h:form>
                                        <h5><h:form>by <h:commandLink action="#{theBooks.processAuthorSearch(book.authorId.name)}">#{book.authorId.name}</h:commandLink></h:form></h5>
                                        <p:rating value="3" readonly="true" />
                                        <button class="collapsible">more info</button>
                                        <div class="collapsibleInfo">
                                            <p class="collapsibleText">#{book.description}</p>
                                            <p class="collapsibleText">#{msgs.numOfPages}: #{book.numberOfPages}</p>
                                            <p class="collapsibleText">#{msgs.isbn}: #{book.isbn}</p>
                                        </div>

                                    </td>
                                    <td>
                                        <p>
                                            <span jsf:rendered="#{book.salePrice eq book.listPrice}">#{book.listPrice}</span>
                                            <span jsf:rendered="#{book.salePrice ne book.listPrice}">
                                                <span style="text-decoration: line-through; color:black;">#{book.listPrice}</span><br/>
                                                #{book.salePrice}
                                            </span>
                                        </p>
                                    </td>
                                    <td><h:form><h:commandLink action="#{shoppingCartBean.remove(book.isbn)}">#{msgs.remove}</h:commandLink></h:form></td>
                                </tr>
                                </ui:repeat>
                            </tbody>
                            </table>
                            
                        

                    </div>
                    <div><h:outputLabel rendered="#{shoppingCartBean.isEmpty()}">#{msgs.emptyCart}</h:outputLabel></div>
                    
                    <ui:fragment rendered="#{user.logged}">
                        <!--Totals:-->
                        <div class="pull-right">
                            <!--Taxes: GST, PST, QST, HST -->      
                            <table class="totalTable">
                            <tbody>
                                <tr>
                                    <td>#{msgs.totalBooksInCart}</td>
                                    <td>#{shoppingCartBean.shoppingListLength}</td>
                                </tr>
                                <tr>
                                    <td>#{msgs.subtotal}</td>
                                    <td>CAN$ #{shoppingCartBean.shoppingListTotal}</td>
                                </tr>
                                <tr>
                                    <td>#{msgs.youSaved}</td>
                                    <td>CAN$ #{shoppingCartBean.savingTotal}</td>
                                </tr>
                                <tr>
                                    <td>#{msgs.taxes}(#{shoppingCartBean.provinceName})</td>
                                    <td>
                                        GST: CAN$ #{shoppingCartBean.GST}<br/>
                                        PST: CAN$ #{shoppingCartBean.PST}<br/>
                                        QST: CAN$ #{shoppingCartBean.QST}<br/>
                                        HST: CAN$ #{shoppingCartBean.HST}
                                    </td>
                                </tr>
                            </tbody>
                            </table>
                        </div>
                        <div class="clearfix"></div>
                        <hr/>
                        
                        <div class="pull-right">
                            <h4>
                                #{msgs.total}: CAN$ #{shoppingCartBean.totalPrice}
                            </h4>
                        </div>
                        
                    </ui:fragment>
                    
                    <div class="pull-left">
                            <h4>
                                <a href="index.xhtml"><span class="glyphicon glyphicon-arrow-left"/> #{msgs.continueShopping}</a>
                            </h4>
                    </div>
                    <div class="clearfix"></div>
                    
                </div>
                
            </div>
            <!-- Check out -->
            <div class="col-sm-offset-2 col-sm-8 col-md-offset-0 col-md-4 mt-3">
                <div class="p-3 gradientGray textWhite cardShadow">
                    
                    <!-- in case the user is not logged in show this section -->
                    <h:form rendered="#{!user.logged}" class="pl-4 pr-4">
                        <div class="form-group">
                            <p:outputLabel value="#{msgs.cartWithNonLoggedInUser}" />
                        </div>
                        <h:commandButton  type="submit" action="signin.xhtml" class="btn btn-default btn-block orangeBackground textWhite" value="#{msgs.login}"/>
                    </h:form>
                    
                    <!-- if the user logged in he can checkout -->
                    <h:form  rendered="#{user.logged}" class="pl-4 pr-4">
                        <!-- Name on card -->
                        <div class="form-group">
                            <p:outputLabel for="nameOnCard" value="#{msgs.nameOnCard}" />
                            <p:inputText class="form-control underline textWhite" id="nameOnCard" placeholder="Your Name" requiredMessage="#{msgs.inValidName}"/>
                        </div>
                        <!-- card Number -->
                        <div class="form-group">
                            <p:outputLabel for="cardNumber" value="#{msgs.cardNumber}" />
                            <p:inputText class="form-control underline textWhite" id="cardNumber" value="#{transactionController.card}" required="true" maxlength="19" placeholder="XXXX-XXXX-XXXX-XXXX" requiredMessage="#{msgs.inValidCredit}">
                                <f:converter converterId="com.ga3w20.CreditCardConverter" />
                                <f:validator validatorId="com.ga3w20.CreditCardValidator" />
                            </p:inputText>
                            <h:message for="cardNumber" styleClass="errorMessage" />
                        </div>
                        <div class="form-row">
                            <!-- expiry Date -->
                            <div class="form-group col-xs-6">
                                <p:outputLabel for="cardNumber" value="#{msgs.expiryDate}" />
                                <p:inputText class="form-control underline textWhite" value="#{transactionController.expiry}" id="expiryDate" required="true" placeholder="XX/XX" requiredMessage="#{msgs.inValidDate}" >
                                    <f:convertDateTime pattern="MM/yyyy"/>
                                </p:inputText>
                                <h:message for="expiryDate" styleClass="errorMessage" />
                            </div>
                            <!-- CVV -->
                            <div class="form-group col-xs-6">                                
                                <p:outputLabel for="cvv" value="#{msgs.cvv}" />
                                <p:inputMask class="form-control underline textWhite" id="cvv" maxlength="3" placeholder="XXX" mask="999" required="true" requiredMessage="#{msgs.inValidCvv}"/>
                            </div>
                        </div>
                        <h:commandButton rendered="#{!shoppingCartBean.isEmpty}" type="submit" class="btn btn-default btn-block orangeBackground textWhite" action="#{transactionController.purchase()}" value="#{msgs.checkout}"/>
                        <h:commandButton disabled="true" rendered="#{shoppingCartBean.isEmpty}" type="submit" class="btn btn-default btn-block orangeBackground textWhite" value="#{msgs.noItemsInCart}"/>
                    </h:form>
                </div>
            </div>
        </div>
    </b:container>
    
</ui:composition>
